LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY LCD_CONT IS
	PORT
	(
		B_IORN		: IN	STD_LOGIC;
		B_IOWN		: IN	STD_LOGIC;
		B_RESET		: IN	STD_LOGIC;
		LCD_ADD0	: IN	STD_LOGIC;
		B_CLK		: IN	STD_LOGIC;
		ENABLE		: OUT	STD_LOGIC);
END LCD_CONT;

ARCHITECTURE RTL OF LCD_CONT IS
	SIGNAL	LATCH	: STD_LOGIC_VECTOR(1 downto 0);
	SIGNAL  WRITE	: STD_LOGIC;
	SIGNAL	READ	: STD_LOGIC;
begin
WRITE <= LCD_ADD0 and not B_IOWN;
READ <= LCD_ADD0 and not B_IORN;
	process(WRITE,READ,B_RESET,B_CLK)
	begin
		if (B_RESET='1') then
			LATCH <= "00";
			ENABLE <= '0';
		elsif (READ = '1') then
			ENABLE <= '1';
		elsif (B_CLK'event and B_CLK='1') then
			if (WRITE = '1') then
				LATCH(0) <= '1';
				LATCH(1) <= LATCH(0);
				ENABLE <= WRITE and not LATCH(1);
			elsif (WRITE ='0') then
				ENABLE <= '0';
				LATCH <= "00";
			end if;
		end if;
	end process;
end RTL;

