-- MAX+plus II VHDL Template
-- Clearable loadable enablable counter

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY shift_reg IS

	PORT
	(
		sin,enb,reset		: IN	STD_LOGIC;
		clock				: IN 	std_logic;
		p_out				: OUT 	std_logic_vector(23 downto 0)
	);
	
END shift_reg;

ARCHITECTURE RTL OF shift_reg IS
	SIGNAL temp_p_out : std_logic_vector(23 downto 0);
	
BEGIN

	PROCESS (clock, reset)
	BEGIN
	
		IF reset = '1' THEN
			FOR I IN 0 to 23 LOOP
			temp_p_out(I) <= '0';
			END LOOP;
		ELSIF (clock'EVENT AND clock = '1') THEN
			
			IF enb = '1' THEN
				temp_p_out(0) <= sin;
				FOR I IN 0 to 22 LOOP
					temp_p_out(I+1) <= temp_p_out(I);
				END LOOP;
			ELSE
					temp_p_out <= temp_p_out;				
			END IF;
			
		END IF;
		
	END PROCESS;
	p_out <= temp_p_out;
END RTL;

